/****************************
 * Project : Feuchtigkeitskontroller
 * 
 * Author  : Aida Mihat & Dante Ros
 * 
 * Date    :  29 Mei 2018
 * 
 * Description : This cooding is created to monitor soil moisture status which can be monitor by using Anroid through BLE connection. The controller has been done using ESP32 Microcontroler.
 */


#include <Wire.h>
#include <BLEDevice.h>
#include <BLEServer.h>
#include <BLEUtils.h>
#include <BLE2902.h>
#define TRIGGER 33
#define ECHO 27

long duration;
long distance;
long Wasserniveau;
int sensor_pin =32;
 

BLECharacteristic *pCharacteristic;
bool deviceConnected = false;
String txValue = "";

#define SERVICE_UUID           "6E400001-B5A3-F393-E0A9-E50E24DCCA9F" // UART service UUID
#define CHARACTERISTIC_UUID_RX "6E400002-B5A3-F393-E0A9-E50E24DCCA9F"
#define CHARACTERISTIC_UUID_TX "6E400003-B5A3-F393-E0A9-E50E24DCCA9F"


void setup() {
  
  Serial.begin (115200);
  //pinMode(led_pin, OUTPUT);
  pinMode(sensor_pin, INPUT);

  pinMode(TRIGGER,OUTPUT);
  pinMode(ECHO,INPUT);
  
}

void loop() 

{
  digitalWrite(TRIGGER, LOW);
  delayMicroseconds(2);

  digitalWrite(TRIGGER,HIGH);
  delayMicroseconds (10);

  digitalWrite (TRIGGER, LOW);
  duration = pulseIn(ECHO, HIGH);
  distance= (duration/2)/ 29.1;
  Wasserniveau= 21 - distance;

  
//Description of water level status
  if (Wasserniveau <=8){
    
    Serial.printf("Wasser fast leer !!"); Serial.println (Wasserniveau); }
  else {
    Serial.printf("Wasserniveau in cm :"); Serial.println(Wasserniveau);
  delay (500);
  }
///////////////////////////////////////////////////////////////////////////


  if(digitalRead(sensor_pin) == HIGH && Wasserniveau <=8)
  
   { 
    //Serial.println("dry"); 
     if (deviceConnected) {

          txValue = "dry";
          char *cstr = new char[txValue.length() + 1];
          strcpy(cstr, txValue.c_str());
          pCharacteristic->setValue(cstr);

          pCharacteristic->notify(); // Send the value to the app!
          Serial.print("*** Sent Value: ");
          Serial.print(txValue);
          Serial.println(" ***");

        }
   } 
 else
    {
   // Serial.println("wet");
    if (deviceConnected) {

          txValue = "wet";
          char *cstr = new char[txValue.length() + 1];
          strcpy(cstr, txValue.c_str());
          pCharacteristic->setValue(cstr);

          pCharacteristic->notify(); // Send the value to the app!
          Serial.print("*** Sent Value: ");
          Serial.print(txValue);
          Serial.println(" ***");

        }
    delay (500);
    }
}



